
#include <device.h>
#include "stdio.h"
uint8 DMADone_flag = 0; // see ISR_DMA_Done.c   p30, 170   
uint8 cnt = 0;
uint16 sample16[32];    // for ADC
int i=0;

int main()
{
CYGlobalIntEnable;      
ISR_DMA_Done_Start();  
Clock_1_Start();  
WaveDAC8_1_Start();
ADC_DelSig_Start();         // Start ADC */ 
ADC_DelSig_IRQ_Disable();   /* The ADC Interrupt is disabled because the system doesn't need the interrupt */
ADC_DelSig_StartConvert();  /* Start ADC conversion */

USBUART_Start(0, USBUART_5V_OPERATION);  
while(!USBUART_bGetConfiguration()) {} ;	/* Wait for Device to enumerate */

    /* Enumeration is done, enable OUT endpoint for receive data from Host */
    USBUART_CDC_Init();  
//------------------------------------------------------------------------------------------------------------------
	for(;;)
 	{
	  if(DMADone_flag)  //ADC Interrupt flag
		{
		sample16[cnt] = ADC_DelSig_GetResult16(); 	// ADC read
		cnt++;		DMADone_flag=0;   			 	// reset ADC Interrupt flag
	  	}
		
		
		 if(cnt==32)	//accumulated 32x2 bytes, send to USBUART
		{
		  	cnt=0;
			while(USBUART_CDCIsReady() == 0u){};    /* Wait till component is ready to send more data to the PC */ 
			USBUART_PutData( (uint8*)&sample16  ,64);       // send 64 byte to USBUART
		 	//while(USBUART_CDCIsReady() == 0u){}; 	/* Wait till component is ready to send more data to the PC */ 
  		 	//USBUART_PutData(NULL, 0u);        	/* Send zero-length packet to PC */ 
		}
  	}
}

/* [] END OF FILE */